SystemOrganization addCategory: #'Rizel-Spy-Profiler'!

PackageSpy subclass: #MPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler'!

!MPackage class methodsFor: 'as yet unclassified' stamp: ''!
spyClassForClass
	^ MClass! !

MethodSpy subclass: #MMethod
	instanceVariableNames: 'numberOfCalls depthMax depthMin isRelevantCache argumentTable performLocalSideEffect receiverTable returnValueTable sameReturnValuePerReceiverBoolean returnSelf numberOfDifferentReceiversAtLeastCache copySourceCode tally'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler'!

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:44'!
argumentTable
	^ argumentTable ifNil: [
		argumentTable := Array new:  4096
	]! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 23:06'!
copySourceCode
	^ copySourceCode ! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:44'!
depthMax 
	^ depthMax ! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:44'!
depthMin 
	^ depthMin! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/10/2012 15:10'!
executionTime: aNumber
	super executionTime: aNumber.
	tally := true.! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
hasAlwaysTheSameReturnValue
	^ (self returnValueTable select: #notNil) asSet size = 1! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:45'!
hasSameReturnValuePerReceiver
	^ sameReturnValuePerReceiverBoolean  ! !

!MMethod methodsFor: 'support private' stamp: 'JuanPabloSandovalA 6/9/2012 16:47'!
increaseNumberOfCalls

	numberOfCalls := numberOfCalls + 1! !

!MMethod methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalA 6/10/2012 15:09'!
initialize
	super initialize.
	executionTime := 0.
	performLocalSideEffect := false.
	numberOfCalls := 0.
	depthMin := 0.
	depthMax := 0.
	sameReturnValuePerReceiverBoolean := true.

	returnSelf := false.
	tally := false.
! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
isCovered
	^ numberOfCalls > 0! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
isLeaf
	^ self outgoingCalls isEmpty! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
isNotLeaf
	^ self isLeaf not! !

!MMethod methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 6/10/2012 14:15'!
numberOfCalls
	^ numberOfCalls.! !

!MMethod methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 6/9/2012 16:49'!
numberOfDifferentReceiversAtLeast
	numberOfDifferentReceiversAtLeastCache ifNotNil: [ ^ numberOfDifferentReceiversAtLeastCache ].
	^ numberOfDifferentReceiversAtLeastCache := (self receiverTable select: #notNil) size! !

!MMethod methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 6/9/2012 16:49'!
numberOfIncomingCalls
	^ self incomingCalls size! !

!MMethod methodsFor: 'metrics' stamp: 'JuanPabloSandovalA 6/9/2012 16:49'!
numberOfOutgoingCalls
	^ self outgoingCalls size! !

!MMethod methodsFor: 'hooks' stamp: 'JuanPabloSandovalA 6/9/2012 23:05'!
originalMethod: aCompiledMethod
	super originalMethod: aCompiledMethod.
	copySourceCode  := self sourceCode.! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
performLocalSideEffect
	^ performLocalSideEffect! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
performSideEffect
	^ self withAllOutgoingCalls anySatisfy: #performLocalSideEffect 
	
	"^ self performSideEffectRoot: self"! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
performSideEffectRoot: aProfilingMethodSpy
	
	self isLeaf ifTrue: [ ^ self performLocalSideEffect ].
	
	^ self outgoingCalls anySatisfy: [:outgoingCall |
		outgoingCall == aProfilingMethodSpy ifTrue: [ ^ outgoingCall performLocalSideEffect ].
		outgoingCall performSideEffectRoot: aProfilingMethodSpy
	]! !

!MMethod methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:46'!
performsSideEffect

	^ self withAllOutgoingCalls anySatisfy: #performLocalSideEffect! !

!MMethod methodsFor: 'printing' stamp: 'JuanPabloSandovalA 6/9/2012 16:50'!
printOn: stream 
	super printOn: stream.
	stream nextPut: $ .
	stream nextPutAll: executionTime printString.
	stream nextPutAll: ' ms '.
	self profiler ifNil: [ ^ self ].
	self profiler totalExecutionTime ifNil: [ ^ self ].

	self profiler totalExecutionTime > 0
		ifTrue: [ 
			stream nextPut: $(.
			stream nextPutAll: (executionTime * 100 / self profiler totalExecutionTime) asInteger printString.
			stream nextPut: $%.
			stream nextPut: $) ].
	
	stream nextPutAll: ('<n>executed <1p> time<2s> <n>' expandMacrosWithArguments: {self numberOfCalls . (self numberOfCalls > 1) ifTrue: ['s']ifFalse: [''] }).
"	self isRelevant 
		ifTrue: [ stream cr. stream nextPutAll: ' above time threshold' ].
"		
	self performSideEffect
		ifFalse: [ stream cr. stream nextPutAll: ' performs no side effect' ].
		
"	self hasSameArgumentsPerReceiver 
		ifTrue: [ stream cr. stream nextPutAll: ' and has same arguments per receiver' ].
"
	stream cr.
	stream nextPutAll: 'invoked on at least '.
	stream nextPutAll: self numberOfDifferentReceiversAtLeast printString.
	stream nextPutAll: ' receiver'.
	self numberOfDifferentReceiversAtLeast > 1
		ifTrue: [ stream nextPut: $s ].

	self hasSameReturnValuePerReceiver 
		ifTrue: [ stream cr; nextPutAll: 'same return value per receiver'].

	! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:45'!
receiverTable
	^ receiverTable ifNil: [
		"receiverTable := Array new:  4096"
		receiverTable := BoundedDictionary new.
	]! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:45'!
returnSelf
	^ returnSelf! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/9/2012 16:45'!
returnValueTable
	^ returnValueTable ifNil: [
		"returnValueTable := Array new:  4096"
		returnValueTable := BoundedDictionary new.
	]! !

!MMethod methodsFor: 'hooks' stamp: 'JuanPabloSandovalA 6/10/2012 22:57'!
run: aSelector with: aListOfArguments in: aReceiver

	| v receiverSnapshot returnValueHash receiverHash identityHash argAndReceiverSnapshot |

	numberOfCalls := numberOfCalls + 1.
	
	"receiverSnapshot := aReceiver snapshotAsInteger.
	identityHash := aReceiver identityHash."
"	(identityHash > 4096) ifTrue: [ identityHash := identityHash bitShift: -18 ]."
	"receiverHash := identityHash+ 1."

	"SIDE EFFECT"
	"performLocalSideEffect ifFalse: [
		argAndReceiverSnapshot := receiverHash bitXor: aListOfArguments snapshotAsInteger.
		(self receiverTable includesKey: receiverHash) 
			ifTrue: [ (self receiverTable at: receiverHash) ~= argAndReceiverSnapshot
						ifTrue: [ performLocalSideEffect := true ]]
			ifFalse: [ self receiverTable at: receiverHash put: argAndReceiverSnapshot ]]."
	
	"METHOD EXECUTION"
	v := super run: aSelector with: aListOfArguments in: aReceiver.
	
	"SIDE EFFECT"
	"aReceiver snapshotAsInteger ~= receiverSnapshot
		ifTrue: [ performLocalSideEffect := true ]."
	
	"RETURN VALUE"
	"returnValueHash := v identityHash.
	(self returnValueTable includesKey: receiverHash) 
		ifTrue: [ (self returnValueTable at: receiverHash) ~= returnValueHash 
					ifTrue: [ sameReturnValuePerReceiverBoolean := false ]].
	self returnValueTable at: receiverHash put: returnValueHash.
	(aReceiver == v) ifTrue: [ returnSelf := true ]."
	
	^ v! !

!MMethod methodsFor: 'utils' stamp: 'JuanPabloSandovalA 6/9/2012 16:50'!
useTime: aTally parents: parents

	aTally time ifNil: ["Transcript cr; show: 'the time is still nil:'; show: self printString. executionTime := 700." ^self].
	
	executionTime := aTally time.
	
	executionTime > 0 ifTrue: [(parents anySatisfy: [:e | e method == aTally method]) ifTrue: [depthMax := parents size. ^self]].
	"executionTime := executionTime + aTally time."
	depthMin := parents size! !

!MMethod methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/10/2012 15:10'!
wasTally
	^ tally.! !

Profiler subclass: #MProfiler
	instanceVariableNames: 'inputs dimensions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler'!

!MProfiler class methodsFor: 'as yet unclassified' stamp: ''!
spyClassForPackage
	^ MPackage! !

!MProfiler methodsFor: 'accessing - read only' stamp: 'JuanPabloSandovalA 6/9/2012 16:42'!
allCoveredMethods
	^ self allMethods select: [:m | m executionTime > 0]! !

!MProfiler methodsFor: 'hooks' stamp: 'JuanPabloSandovalA 6/9/2012 16:42'!
getTimeAndCallGraph
	^ true! !

!MProfiler methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalA 6/9/2012 16:43'!
initialize 
	super initialize.
	totalExecutionTime := 1.! !

!MProfiler methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/10/2012 22:21'!
tallyOn: aBlock
	
	| tally |
	tally := Sampling new.
	tally spyEvery: 1 on: [ 100 timesRepeat: aBlock].
	^ tally! !

!MProfiler methodsFor: 'accessing - read only' stamp: 'JuanPabloSandovalA 6/9/2012 16:42'!
totalExecutionTime
	^ totalExecutionTime ! !

ClassSpy subclass: #MClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Spy-Profiler'!

!MClass class methodsFor: 'as yet unclassified' stamp: ''!
spyClassForMethod
	^ MMethod! !

!MClass methodsFor: 'testing' stamp: 'JuanPabloSandovalA 6/9/2012 16:43'!
isCovered
	^ self allMethods anySatisfy: #isCovered! !
